<?php

// PHP IRC bot
// Based on HARVESTER IRC BOT by Harvie

class IRCBot
{
  var $OwnerName = 'Chronosův';
  var $Server = "game.zdechov.net";
  var $Port = 6667;
  var $Channel = "#zdechov";
  var $Nick = "BigBrother";
  var $JokeFileName = "jokes.txt";
  var $File;

  function __construct() 
  {
    $Jokes = file($this->JokeFileName);
    $this->File = fsockopen($this->Server, $this->Port, $ErrNumber, $ErrString, 5);
    $this->Connect($this->File, $this->Nick, $this->Channel, 0);
  }

  function Connect()
  {
    $this->Command('USER USER '.$this->Nick." # # :".$this->Nick);
    $this->Command('NICK '.$this->Nick);
    //sleep($JoinWaitTime);
    $this->Command('JOIN '.$Channel);
  }

  function SayPrivate($Message, $Recepient)
  {
    $this->Command(': PRIVMSG '.$Recepient.' :'.$Message);
  }

  function Say($Message)
  {
    $this->Command(':'.$Message);
  }

  function Command($Text)
  {
    fwrite($this->File, $Text."\n");
  }

  function Run()
  {
    while(!fwrite($this->File, ''))
    {
      $this->Command('JOIN '.$this->Channel);

      $Line = fgets($this->File);
      echo($Line);

      $LineParts = explode(' ', $Line);
      if(count($LineParts) > 0)
      {
        if($LineParts[0] == 'PING')
        {
          $this->Command('PONG '.trim($LineParts[1])."\n");
          echo('-PONG '.trim($LineParts[1])."\n");
        }

        if(count($LineParts) > 1)
        {
          if((trim($LineParts[1]) == 'INVITE') && (substr(trim($LineParts[3]), 0, 2) == ':#'))
          {
            $CurrentChannel = substr(trim($LineParts[3]), 1);
            fwrite($this->File, 'JOIN '.$this->Channel."\n");
            $this->Say('Hello');
            echo('-JOINED '.$this->Channel."\n");
          }
        }
      }

      $Commands = explode(':', $Line);
      foreach($Commands as $Index => $Item)
        $Commands[$Index] = trim($Item);

      if(count($Commands) >= 2)
      {
        $Command = $Commands[2];

        // Jméno - Pošle vizitku
        if($Command == $this->Nick)
        {
          $this->Say('Ahoj lidi, ja jsem '.$this->OwnerName.' bot. Random#: '.rand(0, 10));
          echo('-VISITCARD'."\n");
        }

        // hhelp - vypise tuto napovedu
        if($Command == 'hhelp')
        {
          $this->SayPrivate('Ja jsem Harvester.', $this->Channel);
          /*
          irc_say( $sfp, "Harvester - Posle vizitku", $nick, $channel );
          irc_say( $sfp, "hhelp - vypise tuto napovedu", $nick, $channel );
          irc_say( $sfp, "hsay:Message - Posle zpravu", $nick, $channel );
          irc_say( $sfp, "hpsay:to:Message - Posle soukromou zpravu kanalu nebo osobe", $nick, $channel );
          irc_say( $sfp, "hdo:Command - Posle serveru prikaz", $nick, $channel );
          irc_say( $sfp, "hmove:Channel - Pripoji do kanalu / Zmeni aktivni kanal", $nick, $channel );
          irc_say( $sfp, "/invite Harvester #channel - Pozve a pripoji bota do kanalu", $nick, $channel );
          irc_say( $sfp, "hpart:Channel - Odpoji se z kanalu", $nick, $channel );
          irc_say( $sfp, "hjoke - Posle \"nahodny\" vtip", $nick, $channel );
          */
          echo("-HELPED"."\n");
        }

       // hsay:Message - Posle zpravu
       if($Command == 'hsay')
       {
         $this->SayPrivate($Commands[3], $this->Channel);
         echo("-SAID: ".$Commands[3]."\n");
       }

       // hpsay:to:Message - Posle soukromou zpravu kanalu nebo osobe
       if($Command == 'hpsay')
       {
         $this->SayPrivate($Commands[4], $Commands[3]);
         echo("-SAID: ".$Commands[4]." -- To: ".$Commands[3]."\n");
       }

/*
    // hcol:to:Message - Posle kolizni zpravu kanalu nebo osobe
    if($Command == 'hcol')
    {
      irc_say( $sfp, trim($commands[4]), trim($commands[3]), $channel );
      echo("-COLIDED: ".trim($commands[4])." To: ".trim($commands[3])."\n");
    }

    // hdo:Command - Posle serveru prikaz
    if(trim($commands[2]) == "hdo")
    {
      $hdo = explode("hdo:", $line);
      fwrite( $sfp, trim($hdo[1])."\n" );
      echo("-DONE: ".trim($hdo[1])."\n");
    }

    // hpart:Channel - Odpoji se z kanalu
    if(trim($commands[2]) == "hpart")
    {
      $hdo = explode("hpart:", $line);
      if(trim($hdo[1]) != trim($home_channel))
      {
        fwrite( $sfp, "PART :".trim($hdo[1])."\n" );
        echo("-PARTED: ".trim($hdo[1])."\n");
      }
    }

    // hmove:Channel - Zmeni aktivni kanal
    if(trim($commands[2]) == "hmove")
    {
      $hdo = explode("hmove:", $line);
      if(trim($hdo[1]) != trim($home_channel))
      {
        $home_channel = trim($hdo[1]);
        fwrite($sfp, "JOIN $home_channel\n");
        irc_say( $sfp, "Hi, im here...", $nick, $home_channel );
        echo("-ACTIVATED: ".trim($hdo[1])."\n");
      }
    }

    // htime - udaje o casu
    if(trim($commands[2]) == "htime")
    {
      $msg = implode("-", getdate(time()));
      irc_say( $sfp, trim($msg), $nick, $channel );
      echo("-TIMED"."\n");
    }

    // hjoke - Posle nahodny vtip
    if(trim($commands[2]) == "hjoke") 
    {
      $joke = ($jokes[ rand(0, (sizeof($jokes)-1) ) ]);
      //$ftip = "Potkaji se dve blondyny a jedna rika te druhe: \"How do you do?\" a ta ji odpovi co? kde ses to naucila? To vis vzdycky pretocim radio doprava a tam mluvi jen anglicky tak se to tak ucim. Potkaji se za 2 tydny a jedna rika druhe How do you do a druha ji odpovi chsrchsrsrshchsrshchs";
      irc_say( $sfp, trim($joke), $nick, $channel );
      echo("-JOKED"."\n");
    }
*/    }
    }
    echo("-Connection lost.\n");
  }

}

$IRCBot = new IRCBot();
$IRCBot->Run();

?>